# Batch Connect app configuration file for Jupyter
#
---

# **MUST** set cluster id here that matches cluster configuration file located
# under /etc/ood/config/clusters.d/*.yml
cluster: "dcc"

# All of the attributes that make up the Dashboard form (in respective order),
# and made available to the submit configuration file and the template ERB
# files
#
form:
  - extra_jupyter_args
  - custom_account
  - custom_queue
  - bc_num_hours
  - bc_num_slots
  - num_cpus
  - num_mem
  - num_gpus
  - email
  - addargs
  - jupyter_mode
  - singularity_img
submit: submit.yml.erb
id: submitForm
name : submitForm

# Define attribute values for the dashboard form
attributes:

  # Any extra command line arguments to feed to the `jupyter notebook ...`
  # command that launches the Jupyter notebook within the batch job
  extra_jupyter_args: ""

  custom_account:
    id: custom_account
    label: Account
    widget: select
    cacheable: true
    help: |
    <%- if CustomAccounts.accounts.blank?-%>
      <div class="text-danger">Error while fetching Account. Please contact support!</div>
    <%- else -%>
    options:
    <%- CustomAccounts.accounts.each do |q| -%>
      - [ "<%= q %>", "<%= q %>" ]
    <%- end -%>
    <%- end -%>
  custom_queue:
    id: custom_queue
    label: Partition
    widget: select
    cacheable: true
    help: |
    <%- if CustomQueues.queues.blank?-%>
      <div class="text-danger">Error while fetching Partition. Please contact support!</div>
    <%- else -%>
    options:
    <%- CustomQueues.queues.each do |q| -%>
      - [ "<%= q %>", "<%= q %>" ]
    <%- end -%>
    <%- end -%>

  bc_num_hours:
    id: bc_num_hours
    label: Walltime (Hours)
    help: |
      - Number of hours to allocate
      - Exceeding walltime time will automaticaly stop this job.
    cacheable: true
    widget: number_field
    max: 24
    min: 1
    step: 1
    value: 1
  bc_num_slots: 1
  num_cpus:
    id: num_cpus
    label: CPUs (Threads)
    help: Number of CPU threads
    cacheable: true
    widget: number_field
    max: 40
    min: 2
    step: 2
    value: 2
  num_mem:
    id: num_mem
    label: Memory (GB/Gigabytes)
    help: Total memory is available to all assigned threads!
    cacheable: true
    widget: number_field
    max: 208
    min: 1
    step: 1
    value: 2
  num_gpus:
    id: num_gpus
    label: "GPUs"
    help: "Number of GPU or CUDA devices. You should also have selected a partition that has GPU nodes. Most GPU nodes only have 1 GPU assigned to them."
    cacheable: false
    widget: number_field
    max: 2
    min: 0
    step: 1
    value: 0
  email:
    id: email
    label: Email Address
    help: |
      Enter your email address if you would like to receive job notifications (start, finished, failed, etc..).  Otherwise, leave the field empty.

      --------------------------
    cacheable: true
    widget: text_field

  addargs:
    widget: "text_field"
    id: addargs
    label: "Any additional Slurm parameters e.g. -w dcc-core-01"

  jupyter_mode:
    widget: select
    cacheable: true
    label: "Jupyter Lab or Jupyter Notebook?"
    id: jupyter_mode
    options: 
      - ['Jupyter Lab', 'lab']
      - ['Jupyter Notebook', 'notebook']
    value: 'Jupyter Lab'
    help: |
      Not all container images support both Jupyter Lab and Jupyter Notebook. Container launch will fail if a selected option is not supported by the image.


  singularity_img:
    id: singularity_img
    label: Singularity Container File
    help: |
      Select a Singularity Container (.sif/.simg) that includes Jupyter Lab or Jupyter Notebook.
    cacheable: true
    data-filepicker: true
    data-target-file-type: files
    data-target-file-pattern: '(.simg|.sif)$'
    data-file_picker_favorites: '[{"title": "/work", "href": "/work"},
				  {"title": "/opt/apps", "href": "/opt/apps"}
				 ]'
    data-default-directory: '/opt/apps/community'
    readonly: true
    value: '/opt/apps/community/.'
